diff --git a/src/util-debug.h b/src/util-debug.h
index 18cb93b..959dc2a 100644
--- a/src/util-debug.h
+++ b/src/util-debug.h
@@ -2,7 +2,10 @@
  *  \author Anoop Saldanha <poonaatsoc@gmail.com>
  */
 
-#include <stdio.h>
+#ifndef __UTIL_DEBUG_H__
+#define __UTIL_DEBUG_H__
+
+#include "suricata-common.h"
 #include "threads.h"
 #include <stdint.h>
 
@@ -11,8 +14,14 @@
 #include "pcre.h"
 #include "util-debug-filters.h"
 
-#ifndef __UTIL_DEBUG_H__
-#define __UTIL_DEBUG_H__
+extern SCEnumCharMap sc_log_level_map[11];
+extern SCEnumCharMap sc_log_op_iface_map[4];
+extern SCEnumCharMap sc_syslog_facility_map[22];
+
+/**
+ * \brief Returns the full path given a file and configured log dir
+ */
+char *SCLogGetLogFilename(char *);
 
 /**
  * \brief ENV vars that can be used to set the properties for the logging module
@@ -73,6 +82,7 @@ typedef enum {
 #define SC_LOG_DEF_SYSLOG_FACILITY_STR "local0"
 #define SC_LOG_DEF_SYSLOG_FACILITY LOG_LOCAL0
 
+
 /**
  * \brief Structure to be used when log_level override support would be provided
  *        by the logging module
@@ -520,4 +530,473 @@ void SCLogRegisterTests(void);
 
 void SCLogLoadConfig(void);
 
+/** --------- Inline functions -------- */
+
+#if 0
+static inline void SCLogFreeLogConfig(SCLogConfig *);
+static inline SCLogOPIfaceCtx *SCLogAllocLogOPIfaceCtx();
+static inline SCLogOPIfaceCtx *SCLogInitFileOPIface(const char *, const char *, int );
+static inline SCLogOPIfaceCtx *SCLogInitConsoleOPIface(const char *, SCLogLevel );
+static inline SCLogOPIfaceCtx *SCLogInitSyslogOPIface(int, const char *, SCLogLevel );
+static inline void SCLogFreeLogOPIfaceCtx(SCLogOPIfaceCtx *);
+static inline void SCLogSetLogLevel(SCLogInitData *, SCLogConfig *);
+static inline void SCLogSetLogFormat(SCLogInitData *, SCLogConfig *);
+static inline void SCLogSetOPIface(SCLogInitData *, SCLogConfig *);
+static inline void SCLogSetOPFilter(SCLogInitData *, SCLogConfig *);
+static inline int SCLogMapLogLevelToSyslogLevel(int );
+static inline void SCLogPrintToStream(FILE *, char *);
+static inline void SCLogPrintToSyslog(int , const char *);
+#endif
+
+/**
+ * \brief Frees the output_interface context supplied as an argument
+ *
+ * \param iface_ctx Pointer to the op_interface_context to be freed
+ */
+static inline void SCLogFreeLogOPIfaceCtx(SCLogOPIfaceCtx *iface_ctx)
+{
+    SCLogOPIfaceCtx *temp = NULL;
+
+    while (iface_ctx != NULL) {
+        temp = iface_ctx;
+
+        if (iface_ctx->file_d != NULL)
+            fclose(iface_ctx->file_d);
+
+        if (iface_ctx->file != NULL)
+            free((void *)iface_ctx->file);
+
+        if (iface_ctx->log_format != NULL)
+            free((void *)iface_ctx->log_format);
+
+        if (iface_ctx->iface == SC_LOG_OP_IFACE_SYSLOG) {
+            closelog();
+        }
+
+        iface_ctx = iface_ctx->next;
+
+        free(temp);
+    }
+
+    return;
+}
+
+
+/**
+ * \brief Frees the logging module context
+ */
+static inline void SCLogFreeLogConfig(SCLogConfig *sc_lc)
+{
+    if (sc_lc != NULL) {
+        if (sc_lc->startup_message != NULL)
+            free(sc_lc->startup_message);
+        if (sc_lc->log_format != NULL)
+            free(sc_lc->log_format);
+
+        SCLogFreeLogOPIfaceCtx(sc_lc->op_ifaces);
+        free(sc_lc);
+    }
+
+    return;
+}
+
+/**
+ * \brief Returns a new output_interface_context
+ *
+ * \retval iface_ctx Pointer to a newly allocated output_interface_context
+ */
+static inline SCLogOPIfaceCtx *SCLogAllocLogOPIfaceCtx()
+{
+    SCLogOPIfaceCtx *iface_ctx = NULL;
+
+    if ( (iface_ctx = malloc(sizeof(SCLogOPIfaceCtx))) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(iface_ctx, 0, sizeof(SCLogOPIfaceCtx));
+
+    return iface_ctx;
+}
+
+/**
+ * \brief Initializes the file output interface
+ *
+ * \param file       Path to the file used for logging purposes
+ * \param log_format Pointer to the log_format for this op interface, that
+ *                   overrides the global_log_format
+ * \param log_level  Override of the global_log_level by this interface
+ *
+ * \retval iface_ctx Pointer to the file output interface context created
+ */
+static inline SCLogOPIfaceCtx *SCLogInitFileOPIface(const char *file,
+                                                    const char *log_format,
+                                                    int log_level)
+{
+    SCLogOPIfaceCtx *iface_ctx = SCLogAllocLogOPIfaceCtx();
+
+    iface_ctx->iface = SC_LOG_OP_IFACE_FILE;
+
+    if (file != NULL &&
+        (iface_ctx->file = strdup(file)) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+
+    if ( (iface_ctx->file_d = fopen(file, "w+")) == NULL) {
+        printf("Error opening file %s\n", file);
+        return NULL;
+    }
+
+    if (log_format != NULL &&
+        (iface_ctx->log_format = strdup(log_format)) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+
+    iface_ctx->log_level = log_level;
+
+    return iface_ctx;
+}
+
+/**
+ * \brief Initializes the console output interface
+ *
+ * \param log_format Pointer to the log_format for this op interface, that
+ *                   overrides the global_log_format
+ * \param log_level  Override of the global_log_level by this interface
+ *
+ * \retval iface_ctx Pointer to the console output interface context created
+ */
+static inline SCLogOPIfaceCtx *SCLogInitConsoleOPIface(const char *log_format,
+                                                       SCLogLevel log_level)
+{
+    SCLogOPIfaceCtx *iface_ctx = SCLogAllocLogOPIfaceCtx();
+
+    if ( (iface_ctx = malloc(sizeof(SCLogOPIfaceCtx))) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(iface_ctx, 0, sizeof(SCLogOPIfaceCtx));
+
+    iface_ctx->iface = SC_LOG_OP_IFACE_CONSOLE;
+
+    if (log_format != NULL &&
+        (iface_ctx->log_format = strdup(log_format)) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+
+    iface_ctx->log_level = log_level;
+
+    return iface_ctx;
+}
+
+/**
+ * \brief Initializes the syslog output interface
+ *
+ * \param facility   The facility code for syslog
+ * \param log_format Pointer to the log_format for this op interface, that
+ *                   overrides the global_log_format
+ * \param log_level  Override of the global_log_level by this interface
+ *
+ * \retval iface_ctx Pointer to the syslog output interface context created
+ */
+static inline SCLogOPIfaceCtx *SCLogInitSyslogOPIface(int facility,
+                                                      const char *log_format,
+                                                      SCLogLevel log_level)
+{
+    SCLogOPIfaceCtx *iface_ctx = SCLogAllocLogOPIfaceCtx();
+
+    if ( (iface_ctx = malloc(sizeof(SCLogOPIfaceCtx))) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+    memset(iface_ctx, 0, sizeof(SCLogOPIfaceCtx));
+
+    iface_ctx->iface = SC_LOG_OP_IFACE_SYSLOG;
+
+    if (facility == -1)
+        facility = SC_LOG_DEF_SYSLOG_FACILITY;
+    iface_ctx->facility = facility;
+
+    if (log_format != NULL &&
+        (iface_ctx->log_format = strdup(log_format)) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+
+    iface_ctx->log_level = log_level;
+
+    openlog(NULL, LOG_NDELAY, iface_ctx->facility);
+
+    return iface_ctx;
+}
+
+/**
+ * \brief Internal function used to set the logging module global_log_level
+ *        during the initialization phase
+ *
+ * \param sc_lid The initialization data supplied.
+ * \param sc_lc  The logging module context which has to be updated.
+ */
+static inline void SCLogSetLogLevel(SCLogInitData *sc_lid, SCLogConfig *sc_lc)
+{
+    SCLogLevel log_level = SC_LOG_NOTSET;
+    const char *s = NULL;
+
+    if (sc_lid != NULL)
+        log_level = sc_lid->global_log_level;
+    else {
+        s = getenv(SC_LOG_ENV_LOG_LEVEL);
+        if (s != NULL)
+            log_level = SCMapEnumNameToValue(s, sc_log_level_map);
+    }
+
+    /* deal with the global_log_level to be used */
+    if (log_level > SC_LOG_NOTSET && log_level < SC_LOG_LEVEL_MAX)
+        sc_lc->log_level = log_level;
+    else {
+        sc_lc->log_level = SC_LOG_DEF_LOG_LEVEL;
+#ifndef UNITTESTS
+        printf("Warning: Invalid global_log_level assigned by user.  Falling "
+               "back on the default_log_level \"%s\"\n",
+               SCMapEnumValueToName(sc_lc->log_level, sc_log_level_map));
+#endif
+    }
+
+    /* we also set it to a global var, as it is easier to access it */
+    sc_log_global_log_level = sc_lc->log_level;
+
+#ifdef DEBUG
+    printf("sc_log_global_log_level: %d\n", sc_log_global_log_level);
+#endif
+
+    return;
+}
+
+/**
+ * \brief Internal function used to set the logging module global_log_format
+ *        during the initialization phase
+ *
+ * \param sc_lid The initialization data supplied.
+ * \param sc_lc  The logging module context which has to be updated.
+ */
+static inline void SCLogSetLogFormat(SCLogInitData *sc_lid, SCLogConfig *sc_lc)
+{
+    char *format = NULL;
+
+    if (sc_lid != NULL)
+        format = sc_lid->global_log_format;
+    else
+        format = getenv(SC_LOG_ENV_LOG_FORMAT);
+
+    /* deal with the global log format to be used */
+    if (format == NULL || strlen(format) > SC_LOG_MAX_LOG_FORMAT_LEN) {
+        format = SC_LOG_DEF_LOG_FORMAT;
+#ifndef UNITTESTS
+        printf("Warning: Invalid global_log_format supplied by user or format "
+               "length exceeded limit of \"%d\" characters.  Falling back on "
+               "default log_format \"%s\"\n", SC_LOG_MAX_LOG_FORMAT_LEN,
+               format);
+#endif
+    }
+
+    if (format != NULL &&
+        (sc_lc->log_format = strdup(format)) == NULL) {
+        printf("Error allocating memory\n");
+        exit(EXIT_FAILURE);
+    }
+
+#ifdef DEBUG
+    printf("sc_lc->log_format: %s\n", sc_lc->log_format);
+#endif
+
+    return;
+}
+
+/**
+ * \brief Internal function used to set the logging module global_op_ifaces
+ *        during the initialization phase
+ *
+ * \param sc_lid The initialization data supplied.
+ * \param sc_lc  The logging module context which has to be updated.
+ */
+static inline void SCLogSetOPIface(SCLogInitData *sc_lid, SCLogConfig *sc_lc)
+{
+    SCLogOPIfaceCtx *op_ifaces_ctx = NULL;
+    int op_iface = 0;
+    const char *s = NULL;
+
+    if (sc_lid != NULL && sc_lid->op_ifaces != NULL) {
+        sc_lc->op_ifaces = sc_lid->op_ifaces;
+        sc_lid->op_ifaces = NULL;
+        sc_lc->op_ifaces_cnt = sc_lid->op_ifaces_cnt;
+    }
+    else {
+        s = getenv(SC_LOG_ENV_LOG_OP_IFACE);
+        if (s != NULL) {
+            op_iface = SCMapEnumNameToValue(s, sc_log_op_iface_map);
+
+            if(op_iface < 0 || op_iface >= SC_LOG_OP_IFACE_MAX) {
+                op_iface = SC_LOG_DEF_LOG_OP_IFACE;
+#ifndef UNITTESTS
+                printf("Warning: Invalid output interface supplied by user.  "
+                       "Falling back on default_output_interface \"%s\"\n",
+                       SCMapEnumValueToName(op_iface, sc_log_op_iface_map));
+#endif
+            }
+        }
+        else {
+            op_iface = SC_LOG_DEF_LOG_OP_IFACE;
+#ifndef UNITTESTS
+            printf("Warning: Output_interface not supplied by user.  Falling "
+                   "back on default_output_interface \"%s\"\n",
+                   SCMapEnumValueToName(op_iface, sc_log_op_iface_map));
+#endif
+        }
+
+        switch (op_iface) {
+            case SC_LOG_OP_IFACE_CONSOLE:
+                op_ifaces_ctx = SCLogInitConsoleOPIface(NULL, SC_LOG_LEVEL_MAX);
+                break;
+            case SC_LOG_OP_IFACE_FILE:
+                s = getenv(SC_LOG_ENV_LOG_FILE);
+                if (s == NULL)
+                    s = SCLogGetLogFilename(SC_LOG_DEF_LOG_FILE);
+
+                op_ifaces_ctx = SCLogInitFileOPIface(s, NULL, SC_LOG_LEVEL_MAX);
+                break;
+            case SC_LOG_OP_IFACE_SYSLOG:
+                s = getenv(SC_LOG_ENV_LOG_FACILITY);
+                if (s == NULL)
+                    s = SC_LOG_DEF_SYSLOG_FACILITY_STR;
+
+                op_ifaces_ctx = SCLogInitSyslogOPIface(SCMapEnumNameToValue(s, sc_syslog_facility_map), NULL, -1);
+                break;
+            default:
+                break;
+        }
+        sc_lc->op_ifaces = op_ifaces_ctx;
+        sc_lc->op_ifaces_cnt++;
+    }
+
+    return;
+}
+
+/**
+ * \brief Internal function used to set the logging module op_filter
+ *        during the initialization phase
+ *
+ * \param sc_lid The initialization data supplied.
+ * \param sc_lc  The logging module context which has to be updated.
+ */
+static inline void SCLogSetOPFilter(SCLogInitData *sc_lid, SCLogConfig *sc_lc)
+{
+    const char *filter = NULL;
+
+    int opts = 0;
+    const char *ep;
+    int eo = 0;
+
+    if (sc_lid != NULL)
+        filter = sc_lid->op_filter;
+    else
+        filter = getenv(SC_LOG_ENV_LOG_OP_FILTER);
+
+    if (filter != NULL && strcmp(filter, "") != 0) {
+        sc_lc->op_filter_regex = pcre_compile(filter, opts, &ep, &eo, NULL);
+        if (sc_lc->op_filter_regex == NULL) {
+            printf("pcre compile of \"%s\" failed at offset %d : %s\n", filter,
+                   eo, ep);
+            return;
+        }
+
+        sc_lc->op_filter_regex_study = pcre_study(sc_lc->op_filter_regex, 0,
+                                                  &ep);
+        if (ep != NULL) {
+            printf("pcre study failed: %s\n", ep);
+            return;
+        }
+    }
+
+#ifdef DEBUG
+    printf("SCLogSetOPFilter: filter: %s\n", filter ? filter : "<no filter>");
+#endif
+
+    return;
+}
+
+
+/**
+ * \brief Maps the SC logging level to the syslog logging level
+ *
+ * \param The SC logging level that has to be mapped to the syslog_log_level
+ *
+ * \retval syslog_log_level The mapped syslog_api_log_level, for the logging
+ *                          module api's internal log_level
+ */
+static inline int SCLogMapLogLevelToSyslogLevel(int log_level)
+{
+    int syslog_log_level = 0;
+
+    switch (log_level) {
+        case SC_LOG_EMERGENCY:
+            syslog_log_level = LOG_EMERG;
+        case SC_LOG_ALERT:
+            syslog_log_level = LOG_ALERT;
+        case SC_LOG_CRITICAL:
+            syslog_log_level = LOG_CRIT;
+        case SC_LOG_ERROR:
+            syslog_log_level = LOG_ERR;
+        case SC_LOG_WARNING:
+            syslog_log_level = LOG_WARNING;
+        case SC_LOG_NOTICE:
+            syslog_log_level = LOG_NOTICE;
+        case SC_LOG_INFO:
+            syslog_log_level = LOG_INFO;
+        case SC_LOG_DEBUG:
+            syslog_log_level = LOG_DEBUG;
+        default:
+            syslog_log_level = LOG_EMERG;
+    }
+
+    return syslog_log_level;
+}
+
+/**
+ * \brief Output function that logs a character string out to a file descriptor
+ *
+ * \param fd  Pointer to the file descriptor
+ * \param msg Pointer to the character string that should be logged
+ */
+static inline void SCLogPrintToStream(FILE *fd, char *msg)
+{
+    if (fprintf(fd, "%s", msg) < 0)
+        printf("Error writing to stream using fprintf\n");
+
+    fflush(fd);
+    return;
+}
+
+/**
+ * \brief Output function that logs a character string throught the syslog iface
+ *
+ * \param syslog_log_level Holds the syslog_log_level that the message should be
+ *                         logged as
+ * \param msg              Pointer to the char string, that should be logged
+ *
+ * \todo syslog is thread-safe according to POSIX manual and glibc code, but we
+ *       we will have to look into non POSIX compliant boxes like freeBSD
+ */
+static inline void SCLogPrintToSyslog(int syslog_log_level, const char *msg)
+{
+    //static struct syslog_data data = SYSLOG_DATA_INIT;
+    //syslog_r(syslog_log_level, NULL, "%s", msg);
+
+    syslog(syslog_log_level, "%s", msg);
+
+    return;
+}
+
+
 #endif /* __UTIL_DEBUG_H__ */
diff --git a/src/util-mpm-b2g-cuda.c b/src/util-mpm-b2g-cuda.c
index ff8dc3a..b70a147 100644
--- a/src/util-mpm-b2g-cuda.c
+++ b/src/util-mpm-b2g-cuda.c
@@ -74,12 +74,6 @@ int B2gCudaAddPatternCS(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
                         uint16_t offset, uint16_t depth, uint32_t pid,
                         uint32_t sid);
 int B2gCudaPreparePatterns(MpmCtx *mpm_ctx);
-inline uint32_t B2gCudaScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
-                                PatternMatcherQueue *, uint8_t *buf,
-                                uint16_t buflen);
-inline uint32_t B2gCudaSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
-                                  PatternMatcherQueue *, uint8_t *buf,
-                                  uint16_t buflen);
 uint32_t B2gCudaScan1(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
                       PatternMatcherQueue *, uint8_t *buf, uint16_t buflen);
 
@@ -484,48 +478,6 @@ void MpmB2gCudaRegister(void)
     mpm_table[MPM_B2G_CUDA].RegisterUnittests = B2gCudaRegisterTests;
 }
 
-static inline void B2gCudaEndMatchAppend(MpmCtx *mpm_ctx, B2gCudaPattern *p,
-                                         uint16_t offset, uint16_t depth,
-                                         uint32_t pid, uint32_t sid,
-                                         uint8_t nosearch)
-{
-    MpmEndMatch *em = MpmAllocEndMatch(mpm_ctx);
-    if (em == NULL) {
-        SCLogDebug("ERROR: B2gAllocEndMatch failed");
-        return;
-    }
-
-    SCLogDebug("em alloced at %p", em);
-
-    em->id = pid;
-    em->sig_id = sid;
-    em->depth = depth;
-    em->offset = offset;
-
-    if (nosearch)
-        em->flags |= MPM_ENDMATCH_NOSEARCH;
-
-    if (p->em == NULL) {
-        p->em = em;
-        SCLogDebug("m %p m->sig_id %"PRIu32"", em, em->sig_id);
-        return;
-    }
-
-    MpmEndMatch *m = p->em;
-    while (m->next)
-        m = m->next;
-    m->next = em;
-
-    m = p->em;
-    SCLogDebug("m %p m->sig_id %" PRIu32, m, m->sig_id);
-    while (m->next) {
-        m = m->next;
-        SCLogDebug("m %p m->sig_id %" PRIu32, m, m->sig_id);
-    }
-
-    return;
-}
-
 void B2gCudaPrintInfo(MpmCtx *mpm_ctx)
 {
     B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
@@ -548,36 +500,6 @@ void B2gCudaPrintInfo(MpmCtx *mpm_ctx)
     return;
 }
 
-static inline B2gCudaPattern *B2gCudaAllocPattern(MpmCtx *mpm_ctx)
-{
-    B2gCudaPattern *p = SCMalloc(sizeof(B2gCudaPattern));
-    if (p == NULL) {
-        printf("ERROR: B2gAllocPattern: malloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(p, 0, sizeof(B2gCudaPattern));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(B2gCudaPattern);
-
-    return p;
-}
-
-static inline B2gCudaHashItem *B2gCudaAllocHashItem(MpmCtx *mpm_ctx)
-{
-    B2gCudaHashItem *hi = SCMalloc(sizeof(B2gCudaHashItem));
-    if (hi == NULL) {
-        printf("ERROR: B2gCudaAllocHashItem: malloc failed\n");
-        exit(EXIT_FAILURE);
-    }
-    memset(hi, 0, sizeof(B2gCudaHashItem));
-
-    mpm_ctx->memory_cnt++;
-    mpm_ctx->memory_size += sizeof(B2gCudaHashItem);
-
-    return hi;
-}
-
 static void B2gCudaHashFree(MpmCtx *mpm_ctx, B2gCudaHashItem *hi)
 {
     if (hi == NULL)
@@ -593,93 +515,6 @@ static void B2gCudaHashFree(MpmCtx *mpm_ctx, B2gCudaHashItem *hi)
     return;
 }
 
-static inline void memcpy_tolower(uint8_t *d, uint8_t *s, uint16_t len)
-{
-    uint16_t i;
-    for (i = 0; i < len; i++)
-        d[i] = u8_tolower(s[i]);
-
-    return;
-}
-
-static inline uint32_t B2gCudaInitHash(B2gCudaPattern *p)
-{
-    uint32_t hash = p->len * p->cs[0];
-    if (p->len > 1)
-        hash += p->cs[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline uint32_t B2gCudaInitHashRaw(uint8_t *pat, uint16_t patlen)
-{
-    uint32_t hash = patlen * pat[0];
-    if (patlen > 1)
-        hash += pat[1];
-
-    return (hash % INIT_HASH_SIZE);
-}
-
-static inline int B2gCudaInitHashAdd(B2gCudaCtx *ctx, B2gCudaPattern *p)
-{
-    uint32_t hash = B2gCudaInitHash(p);
-
-    if (ctx->init_hash[hash] == NULL) {
-        ctx->init_hash[hash] = p;
-        return 0;
-    }
-
-    B2gCudaPattern *tt = NULL;
-    B2gCudaPattern *t = ctx->init_hash[hash];
-
-    /* get the list tail */
-    do {
-        tt = t;
-        t = t->next;
-    } while (t != NULL);
-
-    tt->next = p;
-
-    return 0;
-}
-
-static inline int B2gCudaCmpPattern(B2gCudaPattern *p, uint8_t *pat,
-                                    uint16_t patlen, char nocase);
-
-static inline B2gCudaPattern *B2gCudaInitHashLookup(B2gCudaCtx *ctx, uint8_t *pat,
-                                                    uint16_t patlen, char nocase)
-{
-    uint32_t hash = B2gCudaInitHashRaw(pat, patlen);
-
-    if (ctx->init_hash[hash] == NULL)
-        return NULL;
-
-    B2gCudaPattern *t = ctx->init_hash[hash];
-    for ( ; t != NULL; t = t->next) {
-        if (B2gCudaCmpPattern(t, pat, patlen, nocase) == 1)
-            return t;
-    }
-
-    return NULL;
-}
-
-static inline int B2gCudaCmpPattern(B2gCudaPattern *p, uint8_t *pat,
-                                    uint16_t patlen, char nocase)
-{
-    if (p->len != patlen)
-        return 0;
-
-    if (!((nocase && p->flags & B2G_CUDA_NOCASE) ||
-          (!nocase && !(p->flags & B2G_CUDA_NOCASE)))) {
-        return 0;
-    }
-
-    if (memcmp(p->cs, pat, patlen) != 0)
-        return 0;
-
-    return 1;
-}
-
 void B2gCudaFreePattern(MpmCtx *mpm_ctx, B2gCudaPattern *p)
 {
     if (p && p->em)
@@ -706,119 +541,6 @@ void B2gCudaFreePattern(MpmCtx *mpm_ctx, B2gCudaPattern *p)
     return;
 }
 
-static inline int B2gCudaAddPattern(MpmCtx *mpm_ctx, uint8_t *pat,
-                                    uint16_t patlen, uint16_t offset,
-                                    uint16_t depth, char nocase, char scan,
-                                    uint32_t pid, uint32_t sid,
-                                    uint8_t nosearch)
-{
-    B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
-
-    SCLogDebug("ctx %p len %"PRIu16" pid %" PRIu32 ", nocase %s",
-               ctx, patlen, pid, nocase ? "true" : "false");
-
-    if (patlen == 0)
-        return 0;
-
-    /* get a memory piece */
-    B2gCudaPattern *p = B2gCudaInitHashLookup(ctx, pat, patlen, nocase);
-    if (p == NULL) {
-        SCLogDebug("allocing new pattern");
-
-        p = B2gCudaAllocPattern(mpm_ctx);
-        if (p == NULL)
-            goto error;
-
-        p->len = patlen;
-
-        if (nocase)
-            p->flags |= B2G_CUDA_NOCASE;
-
-        /* setup the case insensitive part of the pattern */
-        p->ci = SCMalloc(patlen);
-        if (p->ci == NULL)
-            goto error;
-        mpm_ctx->memory_cnt++;
-        mpm_ctx->memory_size += patlen;
-        memcpy_tolower(p->ci, pat, patlen);
-
-        /* setup the case sensitive part of the pattern */
-        if (p->flags & B2G_CUDA_NOCASE) {
-            /* nocase means no difference between cs and ci */
-            p->cs = p->ci;
-        } else {
-            if (memcmp(p->ci,pat,p->len) == 0) {
-                /* no diff between cs and ci: pat is lowercase */
-                p->cs = p->ci;
-            } else {
-                p->cs = SCMalloc(patlen);
-                if (p->cs == NULL)
-                    goto error;
-                mpm_ctx->memory_cnt++;
-                mpm_ctx->memory_size += patlen;
-                memcpy(p->cs, pat, patlen);
-            }
-        }
-
-        /* put in the pattern hash */
-        B2gCudaInitHashAdd(ctx, p);
-
-        if (mpm_ctx->pattern_cnt == 65535) {
-            printf("Max search words reached\n");
-            exit(1);
-        }
-        if (scan)
-            mpm_ctx->scan_pattern_cnt++;
-        mpm_ctx->pattern_cnt++;
-
-        if (scan) { /* SCAN */
-            if (mpm_ctx->scan_maxlen < patlen)
-                mpm_ctx->scan_maxlen = patlen;
-
-            if (mpm_ctx->scan_minlen == 0)
-                mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen)
-                mpm_ctx->scan_minlen = patlen;
-
-            p->flags |= B2G_CUDA_SCAN;
-        } else { /* SEARCH */
-            if (mpm_ctx->search_maxlen < patlen)
-                mpm_ctx->search_maxlen = patlen;
-
-            if (mpm_ctx->search_minlen == 0)
-                mpm_ctx->search_minlen = patlen;
-            else if (mpm_ctx->search_minlen > patlen)
-                mpm_ctx->search_minlen = patlen;
-        }
-    } else {
-        /* if we're reusing a pattern, check we need to check that it is a
-         * scan pattern if that is what we're adding. If so we set the pattern
-         * to be a scan pattern. */
-        if (scan) {
-            p->flags |= B2G_CUDA_SCAN;
-
-            if (mpm_ctx->scan_maxlen < patlen)
-                mpm_ctx->scan_maxlen = patlen;
-
-            if (mpm_ctx->scan_minlen == 0)
-                mpm_ctx->scan_minlen = patlen;
-            else if (mpm_ctx->scan_minlen > patlen)
-                mpm_ctx->scan_minlen = patlen;
-        }
-    }
-
-    /* we need a match */
-    B2gCudaEndMatchAppend(mpm_ctx, p, offset, depth, pid, sid, nosearch);
-
-    mpm_ctx->total_pattern_cnt++;
-
-    return 0;
-
-error:
-    B2gCudaFreePattern(mpm_ctx, p);
-    return -1;
-}
-
 int B2gCudaAddScanPatternCI(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
                             uint16_t offset, uint16_t depth, uint32_t pid,
                             uint32_t sid, uint8_t nosearch)
@@ -851,23 +573,6 @@ int B2gCudaAddPatternCS(MpmCtx *mpm_ctx, uint8_t *pat, uint16_t patlen,
                              /* scan */0, pid, sid, 0);
 }
 
-static inline uint32_t B2gCudaBloomHash(void *data, uint16_t datalen, uint8_t iter,
-                                        uint32_t hash_size)
-{
-     uint8_t *d = (uint8_t *)data;
-     uint16_t i;
-     uint32_t hash = (uint32_t)u8_tolower(*d);
-
-     for (i = 1; i < datalen; i++) {
-         d++;
-         hash += (u8_tolower(*d)) ^ i;
-     }
-     hash <<= (iter+1);
-     hash %= hash_size;
-
-     return hash;
-}
-
 static void B2gCudaPrepareScanHash(MpmCtx *mpm_ctx)
 {
     B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
@@ -1411,21 +1116,6 @@ void B2gCudaPrintSearchStats(MpmThreadCtx *mpm_thread_ctx)
     return;
 }
 
-static inline int memcmp_lowercase(uint8_t *s1, uint8_t *s2, uint16_t n)
-{
-    size_t i;
-
-    /* check backwards because we already tested the first
-     * 2 to 4 chars. This way we are more likely to detect
-     * a miss and thus speed up a little... */
-    for (i = n - 1; i; i--) {
-        if (u8_tolower(*(s2+i)) != s1[i])
-            return 1;
-    }
-
-    return 0;
-}
-
 void B2gCudaInitCtx(MpmCtx *mpm_ctx, int module_handle)
 {
     SCLogDebug("mpm_ctx %p, ctx %p", mpm_ctx, mpm_ctx->ctx);
@@ -1718,22 +1408,6 @@ void B2gCudaThreadDestroyCtx(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx)
     return;
 }
 
-inline uint32_t B2gCudaScanWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
-                                PatternMatcherQueue *pmq, uint8_t *buf,
-                                uint16_t buflen)
-{
-    B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
-    return ctx ? ctx->Scan(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
-}
-
-inline uint32_t B2gCudaSearchWrap(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
-                                  PatternMatcherQueue *pmq, uint8_t *buf,
-                                  uint16_t buflen)
-{
-    B2gCudaCtx *ctx = (B2gCudaCtx *)mpm_ctx->ctx;
-    return ctx ? ctx->Search(mpm_ctx, mpm_thread_ctx, pmq, buf, buflen) : 0;
-}
-
 uint32_t B2gCudaScanBNDMq(MpmCtx *mpm_ctx, MpmThreadCtx *mpm_thread_ctx,
                           PatternMatcherQueue *pmq, uint8_t *buf,
                           uint16_t buflen)
